# aiota6_monitoring_camera
本フォルダには、ユーザーが本アプリケーションをカスタムする際のインストールディスクイメージ作成方法について記載されています。

## 内容物

### at-debian-builder
本アプリケーションノートを構成するユーザーランドを生成できるソフトウェアです。
**aiota6_resources/** 以下に、最終的にArmadillo上で動作するアプリケーションやEC2上でWebサーバとして動作するアプリケーションなどが含まれています。

リリース版との差異は、上記 **aiota6_resources/** 以下のファイルが追加・修正されているのみです。

使用方法は、
[「Armadillo-IoT ゲートウェイ A6
製品マニュアル Debian GNU/Linux ルートファイルシステムをビルドする」](https://manual.atmark-techno.com/armadillo-iot-a6/armadillo-iota6_product_manual_ja-1.5.0/ch11.html#sct.build.build-debian-rootfs)
をご参照ください。

### make_install_disk_image
at-debian-builderで作成したユーザーランドが組み込まれたインストールディスクイメージを作成できるソフトウェアです。

リリース版との差異は、インストールディスクイメージの第1パーティションに2.1MB程度のスペースを設け、そこに配置したファイルをインストール実行時にユーザーランドに組み込むことができるように改造してあります。

### kernel.patch
USBデバイスの電源制御を可能にするためのデバイスツリーの差分ファイルです。

### README.md
このファイルです。

## 構築手順
### ブートローダーを用意する
ブートローダーは[Armadillo-IoT ゲートウェイ A6 ブートローダー](https://armadillo.atmark-techno.com/resources/software/armadillo-iot-a6/boot-loader)からダウンロード可能です。

ソースコードからビルドする場合は、[「Armadillo-IoT ゲートウェイ A6
製品マニュアル Debian GNU/Linux 11.1. ブートローダーをビルドする」](https://manual.atmark-techno.com/armadillo-iot-a6/armadillo-iota6_product_manual_ja-1.5.0/ch11.html#idm6047)をご参照ください。

### Linuxカーネル、デバイスツリーをビルドする
本アプリケーションで使用するLinuxカーネル、デバイスツリーは以下の手順を行いビルドする必要があります。

#### Linuxカーネルのソースファイルをダウンロードする
[Armadillo-IoT ゲートウェイ A6 Linuxカーネル](https://armadillo.atmark-techno.com/resources/software/armadillo-iot-a6/linux-kernel)から「Linuxカーネル」及び「initramfs アーカイブ」をダウンロードしてください。

その後、[「Armadillo-IoT ゲートウェイ A6
製品マニュアル Debian GNU/Linux 11.2. Linuxカーネルをビルドする
」](https://manual.atmark-techno.com/armadillo-iot-a6/armadillo-iota6_product_manual_ja-1.5.0/ch11.html#idm6069)
に記載されている「1. アーカイブの展開」「2. initramfs アーカイブへのシンボリックリンク作成」の2つの手順を実施してください、

#### USBの電源制御を有効にする
kernel.patchを適用し、arch/arm/boot/dts/armadillo-640.dtsを変更してください。

#### USB Video Class (UVC)を有効にする
以下のコマンドをATDE上で実行し、カーネルコンフィギュレーションを設定します。

```
make ARCH=arm armadillo-640_defconfig
make ARCH=arm menuconfig
```

上記で起動したカーネルコンフィギュレーションの画面で、下記の設定を行います。

```
Device Drivers
[*] Multimedia support                  //　*を付ける
　[*] Cameras/video grabbers support    //　*を付ける
　[*] Media USB Adapters                //　*を付ける
  　[*] USB_VIDEO_CLASS (UVC)           //　*を付ける
```

#### ビルドする
以下のコマンドでビルドを行います。
```
make ARCH=arm CROSS_COMPILE=arm-linux-gnueabihf- LOADADDR=0x82000000 uImage
make ARCH=arm CROSS_COMPILE=arm-linux-gnueabihf-
```

生成されたarch/arm/boot/uImage及びarch/arm/boot/dts/armadillo-iotg-a6.dtbがそれぞれLinuxカーネル、デバイスツリーとなります。

### ユーザーランドを用意する

at-debian-builder/build.shをATDE上で以下のように実行してください。
```
sudo ./build.sh aiota6
```
回線速度などによって40分程度かかる場合があります。
生成されたdebian-buster-armhf-aiota6-[日付].tar.gzがユーザーランドのファイルとなります。

### インストールディスクイメージを作成する

make-install-disk-image/build.shをATDE上で以下のように実行してください。

```
sudo ./build.sh aiota6 "ブートローダー" "Linuxカーネル" "デバイスツリー" "ユーザーランド"
```
適宜ファイル名は置き換えてください。

生成されたinstall-disk-sd-aiota6-[日付].imgがインストールディスクイメージとなります。

### アプリケーションのインストールを行う

アプリケーションノートの手順に従い、インストールを行ってください。
