import os
import boto3
from botocore.exceptions import ClientError
from boto3.dynamodb.conditions import Key

REGION_NAME = 'ap-northeast-1'
TABLE_NAME = ''

def init_aws():
    os.environ['AWS_DEFAULT_REGION'] = REGION_NAME

class DynamoDB:
    def __init__(self):
        self.dynamodb = boto3.resource('dynamodb')
        self.table = self.dynamodb.Table(TABLE_NAME)

    def scan_table(self):
        response = self.table.scan()
        data = response['Items']

        while 'LastEvaluatedKey' in response:
            response = self.table.scan(ExclusiveStartKey=response['LastEvaluatedKey'])
            data.extend(response['Items'])

        return data

    def query_latest_data(self, camera):
        self.table.reload()
        queryData = self.table.query(
            KeyConditionExpression=Key('identifier').eq(camera),
            Limit=1,
            ScanIndexForward=False
        )

        return queryData['Items']
